<html>
<head>
    <title>Aladin atlas</title>
    <meta name="keywords"   content="Aladin, CDS, astronomical data center, sky"/>
    <meta name="Description" CONTENT="Aladin sky atlas">
    <&CDS.headStuff2 "Aladin">
    <script type="text/javascript" src="//aladin.u-strasbg.fr/AladinLite/api/v2/beta/aladin.min.js" charset="utf-8"></script>
    <link rel="stylesheet" href="//aladin.u-strasbg.fr/AladinLite/api/v2/beta/aladin.min.css" />
</head>

<script type='text/javascript'>

    function aladin_init() {
      var hipsDir = "http://alasky.u-strasbg.fr/ancillary/vizier/vizMine/";
      aladin = A.aladin('#aladinLite', {target: '0+0', fov:180, cooFrame:'galactic'});
      aladin.setImageSurvey(aladin.createImageSurvey('vizMine', 'vizMine', hipsDir, 'equatorial', 2, {imgFormat: 'png'}));
      aladin.getBaseImageLayer().getColorMap().update('native');
      aladin.removeLayers();
      return aladin;
    }

    function action_target(aladin, params) {
       var target = params.get("-c");
       var radius = params.get("-c.rm");
       if (target) aladin.gotoObject(target);
       if (radius) aladin.setFov(radius);
    }

    function action_hips(aladin, params) {
        var hips = params.get("hips");
        if (hips) {
            if (hips.find("http:") == 0) aladin.displayFITS(hips);
        }
    }

    function action_source(aladin, params) {
        var sources = params.get("-source");
        var max = params.get("-out.max");
        var moc = params.get("moc");
        var target = params.get("-c");
        var radius = params.get("-c.rm");
        if (sources == null) return;
        if (max == null) max=50;
        var vizurl = "https://"+document.location.hostname+"/viz-bin/votable";
        sourceslist = sources.split(" ");
        for (var i=0; i<sourceslist.length; i++) {
            var url =vizurl+"?-source="+sourceslist[i]+"&-out.add=_RAJ,_DEJ&-oc.form=dm&-out.max="+max;
            if (target) url = url+"&-c="+target;
            if (radius) url = url+"&-c.rm="+radius;
            console.debug("source "+sourceslist[i]+":"+url); 
            aladin.addCatalog(A.catalogFromURL(url, {sourceSize:12, color: '#f08080'}));
            if (moc) {
                 //A.MOCFromURL("http://alasky.u-strasbg.fr/footprints/cats/vizier/"+sourceslist[i]+"?product=MOC&nside=256", {opacity: 0.75});
                 A.MOCFromURL("https://cdsarc.cds.unistra.fr/viz-bin/getMOC/"+sourceslist[i], {opacity: 0.75});
                 aladin.addMOC(moc);
            }
        }
    }

    function action_script() {
        alert("option script is not available yet");
    }

    jqMenu(document).ready(function() {
        const params = new URLSearchParams(window.location.search);
        aladin = aladin_init();

        if (params.get("-c")) action_target(aladin, params);
        if (params.get("-source")) action_source(aladin, params);
        if (params.get("hips")) action_hips(aladin, params);
        if (params.get("script")) action_hips(aladin, params);
    });
</script>

<style>
#aladinLite{width:600px;height:600px;margin: 2em;}
</style>

<body>
    <&CDS.headArea2 "Aladin sky atlas" "aladin">

    <div id='aladinLite'></div>

    <&CDS.tailArea2 "Aladin" "" "aladin">
</body>
</html>
