<html>
<head>
    <&CDS.headStuff2 "VizieR">
    <script type="text/javascript" src="//code.jquery.com/jquery-1.9.1.min.js" charset="utf-8"></script>
    <script type="text/javascript" src="https://aladin.cds.unistra.fr/AladinLite/api/v3/latest/aladin.js" charset="utf-8"></script>
    <link rel="stylesheet" href="/vizier/welcome/css/dataTables.bootstrap.css">
    <link rel="stylesheet" href="/vizier/welcome/css/bootstrap.css">
    <script src="/vizier/welcome/js/bootstrap.min.js"></script>
    <script src="/vizier/welcome/js/jquery.dataTables.min.js"></script>
    <script src="/vizier/welcome/js/dataTables.bootstrap.min.js"></script>
    <script src="/vizier/welcome/js/bootstrap-dialog.min.js" type="text/javascript"></script>
</head>

<style>
#core{margin-left:2%;margin-right:2%;}
#view-image{text-align:center;}
"position{margin-bottom:1em;}
.info{text-align:center; font-type:italique;}
.title{font-weight:bold;}
.ref{Cursor:help;}
.hidden{display:none;}
.on{}
.off{color:grey;}
#menu{padding:0.5em;}
</style>

<script type='text/javascript'>

var aladin;

function executeAladinLite() {
    var hipsDir = "http://alasky.u-strasbg.fr/ancillary/vizier/vizMine/";

//    aladin = A.aladin('#aladinLite', {target: '0+0', fov:180, cooFrame:'galactic'});
    A.init.then(() => {
        aladin = A.aladin('#aladinLite', {fov: 180, projection: "SIN", cooFrame: 'galactic', showCooGridControl: true, showSimbadPointerControl: true, showCooGrid: true, gridOptions: {opacity: 0.3}});

        aladin.setImageSurvey(aladin.createImageSurvey('vizMine', 'vizMine', hipsDir, 'equatorial', 3, {imgFormat: 'png', colormap: 'cubehelix'}));
//        aladin.getBaseImageLayer().getColorMap().update('cubehelix');

        aladin.on('click', function(object) { 
            var position = object.ra+" "+object.dec;
            var http = "/viz-bin/vizmine.exe?-vmine.out=count&-vmine.max=200&-vmine.weight=0&-vmine.sort&-c.rs=20&-c.geom=r";
            http += "&-c="+position;
            console.debug(http);
    
            $.get(http, function(data) {
                 var $xml = $(data).find("VMINE");
                 $("#table").html("");
                 var html = "<div id='position'>Catalogues list arround position "+position+"</div>";
                 html += "<table><thead><th>Name</th><th>Title</th></thead><tbody>";
                 var cats = $xml.find("CAT");
                 for (var i=0; i<cats.length;i++) {
                    var cat = cats.eq(i);
                    html+="<tr><td><a href='<&VizU,u>?";
                    html+="-source="+cat.attr("name")+"'>"+cat.attr("name")+"</a>";
                    html+=" <span class='ref glyphicon glyphicon-info-sign' onClick='displayCatinfo(\""+cat.attr("name")+"\")'> </span>";
    		html+=" <span class='ref' onClick='uploadmoc(\""+cat.attr("name")+"\")'>moc</span>";
                    html+="</td>";
                    html+="<td>"+cat.text()+"</td>";
                    //html+="<td>"+cat.attr("weight")+"</td>";
    		html+="</tr>";
                 }
                 html+="</tbody></table>";
    
                 $("#table").html(html);
    	     $("#table table").dataTable({"bDestroy": true,
                "bProcessing": true,
                "bPaginate": true,
                "bLengthChange": true,
                "bSort": true,
                "bFilter": true,
                "bInfo": true,
                "pageLength": 25,
                "bDeferRender": true});
            });
        });
    });
}

function uploadmoc(cat) {
   aladin.removeLayers();
   var moc = A.MOCFromURL("https://alasky.cds.unistra.fr/footprints/cats/vizier/"+cat+"?product=MOC&nside=256", {opacity: 0.3});
   aladin.addMOC(moc);
}

function displayCatinfo(name) {
    $.get("/viz-bin/ReadMe/"+name, function(data) {
        html ="<table><tbody>";
	var usual= "";
	if (data.alias) usual=" ("+data.alias+")";
        html+="<tr><td class='title'>Name</td><td>"+data.id+usual+"</td></tr>";
        html+="<tr><td class='title'>Bibcode</td><td>"+data.bibcode+"</td></tr>";
        html+="<tr><td class='title'>Author(s)</td><td>"+data.first_author+" "+data.author+"</td></tr>";
        html+="<tr><td class='title'>Date</td><td>"+data.year+"</td></tr>";
        html+="</tbody></table>";
	html+="<h2>Abstract</h2><div class='abstract'>"+data.abstract+"</div>";
        BootstrapDialog.show({ message: html, title: data.title });
    });
}

function setInteractive() {
    $("#menu-interactive").removeClass("off");
    $("#menu-interactive").addClass("on");
    $("#menu-static").removeClass("on");
    $("#menu-static").addClass("off");

    $("#view-interactive").removeClass("hidden");
    $("#view-static").addClass("hidden");
}

function setStatic() {
    $("#menu-static").removeClass("off");
    $("#menu-static").addClass("on");
    $("#menu-interactive").removeClass("on");
    $("#menu-interactive").addClass("off");

    $("#view-static").removeClass("hidden");
    $("#view-interactive").addClass("hidden");
}

$().ready(function() {
    executeAladinLite();
});

</script>

<body>
    <&CDS.headArea2 "VizieR footprint" "vizier">

    <div id='core'>
    <div id='menu' class="panel panel-default">
        Show 
        <a id='menu-interactive' class='on' onClick='setInteractive()'>interactive VizieR coverage</a>
        . <a id='menu-static' class='off' onClick='setStatic()'>static VizieR coverage</a>
    </div>

    <div id='view-static' class='hidden'>
        <center><img src='vizMine.jpg' alt='vizier footprint'/>
        <p>This image had been computed with Aladin</p></center>
    </div>

    <div id='view-interactive' class='row'>
        <div class='col-xs-6' id='aladinLite'></div>
        <div class='col-xs-6' id='table'></div>
    </div>
    </div>

    <&CDS.tail "">
</body>
</html>
